BEGIN 					{ begin_bibliography(); }
/^@[A-Za-z][A-Za-z0-9_-]*/		{ begin_entry(); next; }
/^ *author *= *\"/			{ author_string(); next; }
/^ *editor *= *\"/			{ editor_string(); next; }
/^ *journal *= *\"/		        { journal_string(); next; }
/^ *number *= *\"/			{ number_string(); next; }
/^ *pages *= *\"/			{ pages_string(); next; }
/^ *title *= *\"/			{ title_string(); next; }
/^ *booktitle *= *\"/			{ booktitle_string(); next; }
/^ *volume *= *\"/			{ volume_string(); next; }
/^ *edition *= *\"/			{ edition_string(); next; }
/^ *series *= *\"/			{ series_string(); next; }
/^ *publisher *= *\"/			{ publisher_string(); next; }
/^ *year *= *\"/			{ year_string(); next; }
/^ *type *= *\"/			{ reptype_string(); next; }
/^ *language *= *\"/			{ language_string(); next; }
/^ *seealso *= *\"/                     { seealso_string(); next; }
/^ *URL *= *\"/                         { url_string(); next; }
/^}/ 		 			{ end_entry(); next; }
			 		{ next; }
END				 	{ end_bibliography(); }

function begin_bibliography() 
{
    Row_templ1 = "<tr><td bgcolor=\"#8080FF\" width=\"10%%\">%s</td><td bgcolor=\"#FFFFCC\">%s</td></tr>\n"; 
    Row_templ2 = "<tr><td bgcolor=\"#FF7070\" width=\"10%%\">%s</td><td bgcolor=\"#FFFFCC\">%s</td></tr>\n"; 
    Row_templ3 = "<tr><td bgcolor=\"#B0B0D0\" width=\"10%%\">%s</td><td bgcolor=\"#FFFFCC\">%s</td></tr>\n"; 

    print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"";
    print "\"http://www.w3.org/TR/REC-html40/loose.dtd\">";
    print "<html lang=\"en\">"
    print "<head>"
    print "<meta name=\"author\" content=\"" THENAME "\">";
    print "<meta name=\"description\" content=\"Personal bibliography of " THENAME "\">";
    print "<meta name=\"keywords\" content=\"Publications, Bibliography\">";
    print "<meta name=\"robots\" content=\"index|follow\">"
    print "<meta http-equiv=\"content-type\" content=\"text/html;charset=iso-8859-1\">"
    print "<title>" THENAME " Bibliography</title>"
    print "</head>"
    print "<body bgcolor=\"#DDDDDD\" text=\"#000000\" "
    print "link=\"#0000FF\" alink=\"#FF0000\" vlink=\"#800080\">"

    if (THELOGO != "") {
       print "<p><img src=\"images/" THELOGO "\" alt=\"Logo\"" 
       print "border=0 align=\"right\"></p>"
    }
    print "<h1>Bibliography of " THENAME "</h1>"
    print "<hr noshade>"
    print "<p><a href=\"http://www.lizardtech.com/download.html\">"
    print "<img src=\"images/getdjvu2.gif\" width=\"88\" height=\"31\" border=\"0\"" 
    print "alt=\"Get DjVu-plugin\"></a>"

    print "&nbsp;";
    print "<a href=\"http://www.cs.wisc.edu/~ghost\">"
    print "<img src=\"images/gsview2.gif\" width=\"32\" height=\"32\" border=\"0\""  
    print "alt=\"Get Ghostscript\"></a>"

    print "&nbsp;";
    print "<a href=\"http://www.foolabs.com/xpdf/download.html\">"
    print "<img src=\"images/getxpdf.png\" height=\"32\" width=\"32\" border=\"0\"" 
    print "alt=\"Get Xpdf\"></a>"

    print "&nbsp;";
    print "<a href=\"http://www.math-net.de\">";
    print "<img src=\"images/math-net-small.png\"";
    print "alt=\"Visit Math-Net\""; 
    print "border=\"0\" height=\"32\" width=\"32\" align=\"bottom\"></a>";

    print "&nbsp;";
    print "<a href=\"http://www.zib.de/koch/mopp/howto.html\">"
    print "<img src=\"images/howto.png\" height=\"32\" width=\"32\" border=\"0\" alt=\"How to make a page like this\">&nbsp;How to make a page like this";   
    print "</a></p><p>";

#    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    print "<img src=\"images/papers.gif\" height=\"32\" width=\"32\" border=\"0\" alt=\"Papers Icon\">Articles are marked blue";
    print "&nbsp;&nbsp;";
    print "<img src=\"images/book.gif\" height=\"32\" width=\"32\" border=\"0\" alt=\"Book Icon\">&nbsp;Books are marked red";
    print "&nbsp;&nbsp;";
    print "<img src=\"images/unpublished.png\" height=\"32\" width=\"24\" border=\"0\" alt=\"Unpublished Icon\">&nbsp;Unpublished reports are marked grey";
    print "</p>";

    Entries = 0; 
}

function begin_entry()
{
    Data[Entries, "type"] = entry_type($0);
    Data[Entries, "tag"]  = entry_tag($0);
}

function author_string()
{
    Data[Entries, "author"] = fix_author_editor(fix_line(value($0)));
}

function editor_string()
{
    Data[Entries, "editor"] = fix_author_editor(fix_line(value($0)));
}

function journal_string()
{
    Data[Entries, "journal"] = fix_line(value($0));
}

function number_string()
{
    Data[Entries, "number"] = fix_line(value($0));
}

function pages_string()
{
    Data[Entries, "pages"] = fix_line(value($0));
}

function title_string()
{
    Data[Entries, "title"] = fix_line(value($0));
}

function booktitle_string()
{
    Data[Entries, "booktitle"] = fix_line(value($0));
}

function publisher_string()
{
    Data[Entries, "publisher"] = fix_line(value($0));
}

function volume_string()
{
    Data[Entries, "volume"] = fix_line(value($0));
}

function edition_string()
{
    Data[Entries, "edition"] = fix_line(value($0));
}

function year_string()
{
    Data[Entries, "year"] = fix_line(value($0));
}

function series_string()
{
    Data[Entries, "series"] = fix_line(value($0));
}

function reptype_string()
{
    Data[Entries, "reptype"] = fix_line(value($0));
}

function language_string()
{
    Data[Entries, "language"] = fix_line(value($0));
}

function seealso_string()
{
    Data[Entries, "seealso"] = fix_line(value($0));
}

function url_string()
{
    Data[Entries, "URL"] = fix_line(value($0));
}

function end_entry()
{
    Entries++
}

function end_bibliography()
{
    print "<hr noshade>";
    print_years();
    print "<hr noshade>";
    print_entries();
    print "<hr noshade>";

    print "<a href=\"http://validator.w3.org/check/referer\">";
    print "<img src=\"images/valid-html40.png\" alt=\"Valid HTML 4.0!\"";
    print "border=\"0\" height=\"31\" width=\"88\" align=\"bottom\"></a>";

    print "<a href=\"http://www.anybrowser.org/campaign/\">";
    print "<img src=\"images/anybrowser3.gif\"";
    print "alt=\"Best viewed with any browser\""; 
    print "border=\"0\" height=\"31\" width=\"88\" align=\"bottom\"></a>";

    print "<hr noshade>";
    print "<p><i>Last change " strftime("%d. %b %Y") "</i></p>";
    print "</body></html>";
}

function print_years( theyear,i,count)
{
    theyear = 0;
    count   = 0;

    print "<p>";
    for(i = 0; i < Entries; i++) {
        if (Data[i, "year"] != theyear)	{
            theyear = Data[i, "year"];
            printf("<a href=\"#%s\">[%s]</a>&nbsp;", theyear, theyear);

            if (++count == 10) {
		count = 0;
                print "<br>";
	    }
	}
    }
    print "</p>";
}

function print_entries( theyear,i,k,no,row_templ,a)
{
    theyear = 0;

    for(i = 0; i < Entries; i++) {
        marker = 0;

        if (Data[i, "type"] == "book") 
	    row_templ = Row_templ2;
        else {
	   if ((Data[i, "type"] == "techreport") || (Data[i, "type"] == "misc") || (Datei[i, "type"] == "unpublished"))
	      row_templ = Row_templ3;
	   else
	      row_templ = Row_templ1;
	}

        if (Data[i, "year"] != theyear)	{
            theyear = Data[i, "year"];
            printf("<h2><a name=\"%s\">%s</a></h2>", theyear, theyear);
	}
        printf("<table cellpadding=1 cellspacing=2 border=0 width=\"100%%\">",
	       Data[i, "tag"]);
#       printf("<a name=\"%s\"></a>\n", Data[i, "tag"])         

        if (Data[i, "author"] != "") {
            temp = "<a name=\"" Data[i, "tag"] "\">" Data[i, "author"] "</a>";
	    marker = 1;
	    printf(row_templ, "Authors&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", 
	       temp);
	}
        if (Data[i, "title"] != "")
	{
	    if (Data[i, "URL"] != "") 
		temp = "<a href=\"" Data[i, "URL"] "\">" Data[i, "title"] "</a>";
	    else
                temp = Data[i, "title"];

            if (Data[i, "type"] == "book") {
               if (Data[i, "edition"] != "")
	           temp = temp ", " Data[i, "edition"];
	    }
            if (!marker)
               temp = "<a name=\"" Data[i, "tag"] "\">" temp "</a>";

	    temp2 = "Title";
	    if (Data[i, "language"] != "")
		temp2 = temp2 "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src=\"images/" tolower(Data[i, "language"]) ".png\" height=\"14\" width=\"22\" border=\"0\" align=\"middle\" alt=\"" Data[i, "language"] "\">";
            printf(row_templ, temp2, "<i>" temp "</i>");
	}
        if (Data[i, "editor"] != "")
            printf(row_templ, "Editors",  Data[i, "editor"]);

        if (Data[i, "booktitle"] != "") {
            temp = Data[i, "booktitle"];

            if (Data[i, "type"] == "inbook") {
               if (Data[i, "edition"] != "")
	           temp = temp ", " Data[i, "edition"]
	    }
            printf(row_templ, "Booktitle", "<i>" temp "</i>")
	}
        if ((Data[i, "type"] == "book") || (Data[i, "type"] == "inbook") || (Data[i, "type"] == "incollection") || (Data[i, "type"] == "inproceedings")) {
            temp = "";

            if (Data[i, "series"] != "") {
                temp = Data[i, "series"];
                if (Data[i, "volume"] != "")
                    temp = temp " " Data[i, "volume"];
                temp = temp ", ";
	    }
            if (Data[i, "publisher"] != "")
		temp = temp Data[i, "publisher"] ", ";
           
            if (Data[i, "year"] != "")
                temp = temp Data[i, "year"];

            if (Data[i, "pages"] != "")
		temp = temp ", " Data[i, "pages"];

            printf(row_templ, "Published", temp);
	}
        else if (Data[i, "type"] == "article") {
           # Journal und year muss da sein.
	    temp = Data[i, "journal"] ", ";
	    if (Data[i, "volume"] != "") {
		temp = temp Data[i, "volume"];
                temp = temp ((Data[i, "number"] != "") ? ":" : " ");
	    }
	    if (Data[i, "number"] != "")
		temp = temp Data[i, "number"] " ";
	    if (Data[i, "year"] != "")
		temp = temp "(" Data[i, "year"] ") ";
	    if (Data[i, "pages"] != "")
		temp = temp Data[i, "pages"];

	    printf(row_templ, "Journal", temp);
	}
        else if (Data[i, "type"] == "techreport") {
	    temp = "";
	    if (Data[i, "institution"] != "")
		temp = temp Data[i, "institution"] ", ";
	    if (Data[i, "reptype"] != "")
		temp = temp Data[i, "reptype"] " ";
	    if (Data[i, "number"] != "")
		temp = temp Data[i, "number"] ", ";
	    if (Data[i, "year"] != "")
		temp = temp Data[i, "year"] ;

	    printf(row_templ, "Number", temp);
	}
        else if (Data[i, "year"] != "") {
	    printf(row_templ, "Year", Data[i, "year"]);
	}
	corename = tolower(Data[i, "tag"]);
        temp = "<a href=\"bibs/" corename ".bib.txt\">Get BibTeX entry</a>&nbsp;&nbsp;";

        tag_djvu = "<img src=\"images/djvu.png\" width=\"15\" height=\"16\" border=\"0\" alt=\"Icon DjVu\">";
	tag_pdf  = "<img src=\"images/pdf.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Icon PDF\">";
	tag_ps   = "<img src=\"images/ps.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Postscript\">";
	tag_tex   = "<img src=\"images/tex.png\" width=\"16\" height=\"16\" border=\"0\" alt=\"TeX source\">";

        temp = temp check_for_file(corename, ".djvu",  tag_djvu, "View DjVu");
        temp = temp check_for_file(corename, ".pdf",   tag_pdf,  "View PDF");
        temp = temp check_for_file(corename, ".ps.gz", tag_ps,   "Get PS");
        temp = temp check_for_file(corename, ".tgz",   tag_tex,  "Get TeX");

        printf(row_templ, "Files", temp);

        # --- see also
        if (Data[i, "seealso"] != "") {
	    temp = "";
	    no = split(Data[i, "seealso"], a, ",");
	    for(k = 1; k <= no; k++)
		temp = temp "<a href=\"#" a[k] "\">" a[k] "</a>&nbsp;&nbsp;";
	    printf(row_templ, "See also", temp);
	}
#	    if (Data[i, "URL"] != "") {
#	        no   = split(Data[i, "URL"], a, "://")  
#		temp = temp " <a href=\""Data[i, "URL"] "\">";
#		temp = temp a[no] "</a>";
#	    }        
        print "</table><br>";
    }
}

function check_for_file(corename,extname,image_tag,describtion, temp)
{
    directory = "../html/paper/";
    temp = "";
    if (file_exists(directory corename "_rv" extname)) {
	temp = temp "<a href=\"paper/" corename "_rv" extname "\">" image_tag " " describtion " (revised)</a>&nbsp;&nbsp;";
    }
    else if (file_exists(directory corename extname)) {
	    temp = temp "<a href=\"paper/" corename extname "\">" image_tag " " describtion "</a>&nbsp;&nbsp;";
    }
    else if (file_exists(directory corename "_pp" extname)) {
	    temp = temp "<a href=\"paper/" corename "_pp" extname "\">" image_tag " " describtion " (preprint)</a>&nbsp;&nbsp;";
    }
    return temp;
}

function entry_type(s)
{
    return tolower(substr(s,2,index(s,"{")-2));
}

function entry_tag(s, k1,k2)
{
    # Return the citation tag from a `@EntryType{tag,' line
    k1 = index(s,"{") + 1;
    k2 = index(s,",");
    return (substr(s,k1,k2-k1));
}

function value(s, k1,k2)
{
    # Return the value string, EXCLUDING surrounding quotes, of a
    # `key = "value",' or `key = abbrev' pair
    k1 = index(s,"\"");
    k2 = index(s,"\",");
    if ((k2 == 0) && (k1 > 0))	# recognized unclosed strings
	k2 = length($0) + 1;
    if (k2 > k1)
	return (substr(s,k1+1,k2 - (k1 + 1)));
    k1 = index(s,"= ");
    k2 = index(s,",");
    return (substr(s,k1+2,k2 - (k1 + 2)));
}

function fix_line(s, t)
{
    t = s;
    gsub(/\\v{s}/, "s", t);  # "\\&#154;"
    gsub(/--/, "-", t);
    gsub(/[{}]/, "", t);
    gsub(/\\-/, "", t);
    gsub(/\\ldots/, "...", t);
   
    return t;
}

function fix_author_editor(s, t)
{
    t = s;
    gsub(/ and /, ", ", t);

    return t;
}

function file_exists(filename)
{
    # Unfortunately, getline in both nawk and gawk will hang if its
    # file does not exist, so we need to test for file existence by
    # invoking a shell command, sigh...

    return (system("cat " filename " >/dev/null 2>&1") == 0);
}

