#!/bin/sh
# $Id: ps2djvu.sh,v 1.1.1.1 2002/03/07 15:22:51 bzfkocht Exp $
DPI=300
export LD_LIBRARY_PATH=../djvu/lib:$LD_LIBRARY_PATH
PATH=../djvu/bin:$PATH
#
case $1 in
*.ps)  NAME=`basename $1 .ps`;;
*.eps) NAME=`basename $1 .eps`;;
*.pdf) NAME=`basename $1 .pdf` ;;
*)     echo "Unknown file type " $1
       exit -1;;
esac
echo "Converting to PBM"
gs -sDEVICE=pbm -sOutputFile="p%05d.pbm" -r$DPI -dNOPAUSE -dBATCH -q $1
echo "Converting to JB2"
for i in *.pbm
do
   PAGE=`basename $i .pbm`
   echo "Processing " $PAGE
   cjb2 -dpi $DPI $i $PAGE.jb2
   djvumake $PAGE.djv INFO=",,$DPI" Sjbz=$PAGE.jb2 
   rm $PAGE.pbm $PAGE.jb2 
done
echo "Bundling DJVU file"
djvm -create $NAME.djvu *.djv
rm *.djv
echo "Finished"
