#!/bin/sh
# $Id: tiff2djvu.sh,v 1.1.1.1 2002/03/07 15:22:51 bzfkocht Exp $
export LD_LIBRARY_PATH=../djvu/lib:$LD_LIBRARY_PATH
PATH=../djvu/bin:$PATH
#
case $1 in
*.tif)  NAME=`basename $1 .tif`;;
*.tiff) NAME=`basename $1 .tiff`;;
*)      echo "Unknown file type " $1
        exit -1;;
esac
INVERT=cat
ROTATE=cat
case $2 in
-i*)     INVERT="pnminvert" ;;
-r*)     ROTATE="pnmflip -rotate90" ;;
esac
case $3 in
-i*)     INVERT="pnminvert" ;;
-r*)     ROTATE="pnmflip -rotate90" ;;
esac
echo "Splitting Pages"
tiffsplit $1 page
echo "Converting to JB2"
for i in page*.tif
do
   PAGE=`basename $i .tif`
   echo "Processing " $PAGE
   DPI=`tiffinfo $i | awk -- "/Resolution/ { print \\$3; exit; }"`
   tifftopnm $i | $INVERT | $ROTATE >$PAGE.pbm
   cjb2 -dpi $DPI -clean -loose $PAGE.pbm $PAGE.jb2
   djvumake $PAGE.djv INFO=",,$DPI" Sjbz=$PAGE.jb2 
   rm $PAGE.tif $PAGE.pbm $PAGE.jb2    
done
echo "Bundling DJVU file"
djvm -create $NAME.djvu *.djv
rm *.djv
echo "Finished"




